---
# load shared vars with clusterapi
- name: Include vars
  ansible.builtin.include_vars:
    file: "{{ item }}"
  with_items:
    - ../clusterapi/defaults/main.yml
    - ../configcapo/defaults/main.yml
  tags: [always]

- name: Get Machine details from management cluster
  kubernetes.core.k8s_info:
    kind: Machine
    api_version: cluster.x-k8s.io/v1beta1
    label_selectors:
      - "cluster.x-k8s.io/cluster-name = {{ capi_cluster }}"
  register: workload_machines

- name: Set ssh key
  when: capi_clusterinventory_ssh_extra_args
  ansible.builtin.set_fact:
    ssh_key: "{{ capi_clusterinventory_ssh_dir }}/{{ capi_capo_openstack_ssh_key_name }}.pem"

- name: Show machines
  ansible.builtin.debug:
    var: workload_machines
  when: debug

- name: Create workload cluster inventory in yaml format
  when: capi_clusterinventory_output_yaml
  block:
    - name: Create inventory and set inventory suffix
      ansible.builtin.set_fact:
        cluster_inventory: "{{ workload_machines.resources | get_cluster_inventory(ssh_key | default(None)) }}"
        inventory_suffix: ".inventory.yml"

    - name: Show inventory
      ansible.builtin.debug:
        var: cluster_inventory
      when: debug

    - name: Write workload cluster inventory
      ansible.builtin.copy:
        content: "{{ cluster_inventory | to_nice_yaml(indent=2) }}"
        dest: "{{ capi_config_dir }}/{{ capi_cluster }}{{ inventory_suffix }}"
        mode: "0600"
      become: true

- name: Create workload cluster inventory in ini format
  when: not capi_clusterinventory_output_yaml
  block:
    - name: Set inventory suffix
      ansible.builtin.set_fact:
        inventory_suffix: "-inventory"

    - name: Write workload cluster inventory
      ansible.builtin.template:
        src: inventory.j2
        dest: "{{ capi_config_dir }}/{{ capi_cluster }}{{ inventory_suffix }}"
        mode: "0600"
      become: true

- name: Slurp CAPO Cluster instance manifest
  ansible.builtin.slurp:
    src: "{{ capi_config_dir }}/{{ capi_cluster }}{{ inventory_suffix }}"
  register: slurped_inventory
  become: true

- name: Unpack CAPO Cluster manifest
  ansible.builtin.set_fact:
    capi_cluster_inventory: "{{ slurped_inventory.content | b64decode }}"

- name: "Remove workload local inventory copy ./{{ capi_cluster }}{{ inventory_suffix }}" # noqa: name[template]
  ansible.builtin.file:
    path: "{{ capi_clusterinventory_output_dir }}/{{ capi_cluster }}{{ inventory_suffix }}"
    state: absent
  delegate_to: localhost

- name: Output workload local inventory copy # noqa: template-instead-of-copy
  ansible.builtin.copy:
    content: "{{ capi_cluster_inventory }}"
    dest: "{{ capi_clusterinventory_output_dir }}/{{ capi_cluster }}{{ inventory_suffix }}"
    mode: "0644"
  delegate_to: localhost

- name: Flush those handlers
  ansible.builtin.meta: flush_handlers
